#import('dart:html');
#import('dart:dom', prefix:'dom');
#import('Fireworks.dart');
#import('Bubble.dart');
#import('Letter.dart');
#import("dart:coreimpl");

String char2string(int char)
{
  return StringBase.createFromCharCodes([ char ]);
}

class KeyBoardWarrior {

  int compteurPlus = 0;
  int compteurMoins = 0;
  int gameOver = 0;
  
  CanvasElement frontCanvas;
  int height, width;
  List listFireworks;
  ImageElement volcano;
  AudioElement pong;
  
  int intervalBetweenletter = 50;
  KeyBoardWarrior() {
  }
  
  void loadImage(String src){
    volcano = new Element.tag('img'); 
    volcano.src = src;
    volcano.on.load.add((event) {
         draw(volcano);
    });
  }
 
  
  onKeyboardEvent(KeyboardEvent ke) {
    String letter = char2string(ke.keyCode);
    List listWithoutLetter = listFireworks.filter(f(element) => !(element is Letter) || element.letter != letter);
    List listWithLetter = listFireworks.filter(f(element) => element is Letter && element.letter == letter);
    listFireworks = listWithoutLetter;
    if(listWithLetter.length>0){
      compteurPlus++;
      for(var j=0; j<listWithLetter.length; j++){
        Letter letterInList = listWithLetter[j];
         addExplosionBubble(letterInList.x, letterInList.y);
      }
    }
    if(ke.keyCode==32){
      listFireworks.clear();
      compteurMoins = 0;
      compteurPlus = 0;
      gameOver = 0;
      intervalBetweenletter = 50;
    }
  }
  

  
  void draw(var image){
    var heightImage = image.height;
    var widthImage = image.width;
    ctx.drawImage(image,width/2-widthImage/2,height-heightImage);
  }

  void addExplosionBubble(int x, int y){
    for(var j=0; j<10; j++){
      listFireworks.add(new Bubble(x,y));
    }
  }
  
  void run() {
    frontCanvas = document.query("#canvas");
    onResize();

    listFireworks  = new List(); 
    ctx = frontCanvas.getContext("2d");
  
    loadImage("volcano.png");
    
    ctx.clearRect(0,0,width, height);
    onResize();
    window.on.resize.add((event) => onResize(), true);
    document.window.on.keyDown.add(onKeyboardEvent, false);
    window.webkitRequestAnimationFrame(animate);
  }

  void drawFrame() {
      ctx.clearRect(0, 0, width, height);
      for(int j=0; j<listFireworks.length;j++){
         listFireworks[j].drawFireworks(ctx);
      }
      if(gameOver==0)
        draw(volcano);
      ctx.fillStyle = "white";
      String font = "bold 40px Frijole";
      ctx.font = font;
      ctx.textBaseline  = "middle";
      ctx.fillText("OK : " + compteurPlus, 150, 50);
      ctx.fillText("KO : " + compteurMoins, 150, 100);
      
      int ko = listFireworks.filter(f(e) => e.y <=0 && e is Letter).length;
      compteurMoins+=ko;
      listFireworks = listFireworks.filter(f(e) => e.y >0 && e.x>0 );

  }
  
  
  void animate(int time) {
      drawFrame();
      if(Clock.now()%100==0){
        if(intervalBetweenletter>2)
          intervalBetweenletter--;
      }
      if(Clock.now()%intervalBetweenletter == 0 && gameOver==0){
        int offset = (Math.random()*26).toInt();
        String newLetter = char2string(0x41+offset);
        listFireworks.add(new Letter(width/2,frontCanvas.height-120,newLetter, frontCanvas));
      }
      
      if(compteurMoins>=10){
        if(gameOver==0){
          listFireworks.forEach(function(element)  {
            if(element is Letter){
              for(int j=0; j<50; j++){
                listFireworks.add(new Fireworks(element.x, element.y));
              }
            }
          });
          listFireworks = listFireworks.filter(f(e) => (e is Fireworks));
          gameOver=1;
        }
        ctx.fillStyle = "orange";
        String font = "bold 100px Frijole";
        ctx.font = font;
        ctx.textBaseline  = "middle";
        ctx.fillText("Game Over !" , width/2, height/2-30);
        ctx.font = "bold 50px Frijole";
        ctx.fillText("Imagine by" , width/2, height/2+70);
        ctx.fillText("A Developer Company" , width/2, height/2+110);
        
        ctx.fillText("www.sfeir.com" , width/2, height/2+180);
      }
      window.webkitRequestAnimationFrame(animate);
       
  }
  
  void onResize() {
    height = window.innerHeight - 100;
    width = window.innerWidth - 100;
    frontCanvas.height = height;
    frontCanvas.width = width;
  }
  CanvasRenderingContext2D ctx;
}


void main() {
  new KeyBoardWarrior().run();
}
